<?php
/* ********************************************************************************
 * The content of this file is subject to the Capitalize Fields ("License");
 * You may not use this file except in compliance with the License
 * The Initial Developer of the Original Code is VTExperts.com
 * Portions created by VTExperts.com. are Copyright(C) VTExperts.com.
 * All Rights Reserved.
 * ****************************************************************************** */

require_once('data/CRMEntity.php');
require_once('data/Tracker.php');
require_once 'vtlib/Vtiger/Module.php';

class CapitalizeFields extends CRMEntity {
	/**
	 * Invoked when special actions are performed on the module.
	 * @param String Module name
	 * @param String Event Type (module.postinstall, module.disabled, module.enabled, module.preuninstall)
	 */
	function vtlib_handler($modulename, $event_type) {
		if($event_type == 'module.postinstall') {
            self::addWidgetTo();
		} else if($event_type == 'module.disabled') {
			// TODO Handle actions when this module is disabled.
            self::removeWidgetTo();
		} else if($event_type == 'module.enabled') {
			// TODO Handle actions when this module is enabled.
            self::addWidgetTo();
		} else if($event_type == 'module.preuninstall') {
			// TODO Handle actions when this module is about to be deleted.
		} else if($event_type == 'module.preupdate') {
			// TODO Handle actions before this module is updated.
		} else if($event_type == 'module.postupdate') {
		}
	}	


    /**
     * Add header script to other module.
     * @return unknown_type
     */
    static function addWidgetTo() {
        global $adb;
        $widgetType = 'HEADERSCRIPT';
        $widgetName = 'CapitalizeFieldsJs';
        $link = 'layouts/vlayout/modules/CapitalizeFields/resources/CapitalizeFields.js';
        include_once 'vtlib/Vtiger/Module.php';

        $moduleNames = array('CapitalizeFields');
        foreach($moduleNames as $moduleName) {
            $module = Vtiger_Module::getInstance($moduleName);
            if($module) {
                $module->addLink($widgetType, $widgetName, $link);
            }
        }
        /*$max_id=$adb->getUniqueID('vtiger_settings_field');
		$result =  $adb->pquery("SELECT * FROM vtiger_settings_field WHERE `name` = ?)",array('Capitalize Fields'));
		$numRows = $adb->num_rows($result);	
		if(!($numRows > 0)){
			$adb->pquery("INSERT INTO `vtiger_settings_field` (`fieldid`, `blockid`, `name`, `description`, `linkto`, `sequence`) VALUES (?, ?, ?, ?, ?, ?)",array($max_id,'4','Capitalize Fields','Capitalize Fields', 'index.php?module=CapitalizeFields&parent=Settings&view=Settings',$max_id));
		}*/        
        
    }
	
    static function removeWidgetTo() {
        global $adb;
        $widgetType = 'HEADERSCRIPT';
        $widgetName = 'CapitalizeFieldsJs';
        $link = 'layouts/vlayout/modules/CapitalizeFields/resources/CapitalizeFields.js';
        include_once 'vtlib/Vtiger/Module.php';

        $moduleNames = array('CapitalizeFields');
        foreach($moduleNames as $moduleName) {
            $module = Vtiger_Module::getInstance($moduleName);
            if($module) {
                $module->deleteLink($widgetType, $widgetName, $link);
            }
        }
        $adb->pquery("DELETE FROM vtiger_settings_field WHERE `name` = ?", array('Capitalize Fields'));
    }
}
?>
