<?php
/* ********************************************************************************
 * The content of this file is subject to the Capitalize Fields ("License");
 * You may not use this file except in compliance with the License
 * The Initial Developer of the Original Code is VTExperts.com
 * Portions created by VTExperts.com. are Copyright(C) VTExperts.com.
 * All Rights Reserved.
 * ****************************************************************************** */

class CapitalizeFields_ActionAjax_Action extends Vtiger_Action_Controller {

    function checkPermission(Vtiger_Request $request) {
        return;
    }
    function __construct() {
        parent::__construct();
        $this->exposeMethod('checkEnableModule');
        $this->exposeMethod('saveCapitalizeFields');
    }    
    function process(Vtiger_Request $request) {
        $mode = $request->get('mode');
        if(!empty($mode)) {
            $this->invokeExposedMethod($mode, $request);
            return;
        }
    }
    function checkEnableModule(Vtiger_Request $request) {
        $db = PearDatabase::getInstance();
        $sourceModule = $request ->get('sourceModule');
        /*$sql = 'SELECT status FROM vte_capitalize_fields  LIMIT 0,1';
        $enabled= false;
        $result = $db->pquery($sql, array());
        if ($db->num_rows($result) > 0) {
            $status = $db->query_result($result, 0, 'status');
            if($status) $enabled = true;
        }*/
		$enabled = true;
        $module_modem = Vtiger_Module_Model::getInstance($sourceModule);
        $all_fields = $module_modem ->getFields();
        $string_fields = array();
        $text_type_array = array('string','text','email','salutation');
        foreach($all_fields as $field){
            $type = $field ->getFieldDataType();
            if(in_array($type,$text_type_array)){
                $string_fields[] = $field ->getId();
            }
        }
        //Get all config value
        $configuration_fields = array();
        $sql="SELECT cf.*,f.fieldname FROM `vte_capitalize_fields_list` cf
              INNER JOIN `vtiger_field` f ON f.fieldid = cf.field_id
              WHERE cf.`module` = ? AND cf.`field_id` IN(".implode(',',$string_fields).")";
        $result = $db->pquery($sql,array($sourceModule));
        $noOfRows = $db->num_rows($result);
        if($noOfRows > 0) {
            for($i=0; $i<$noOfRows; ++$i) {
                $field_id = $db->query_result($result,$i,'field_id');
                $method = $db->query_result($result,$i,'method');
                $field_name = $db->query_result($result,$i,'fieldname');
                $configuration_fields[] = array('field_id' => $field_id,'field_name' =>$field_name,'method' => $method);
            }
        }
        $response = new Vtiger_Response();
        $response->setEmitType(Vtiger_Response::$EMIT_JSON);
        $response->setResult( array('success'=>true,'enabled'=>$enabled,'string_fields' =>$string_fields,'configuration_fields' =>$configuration_fields));
        $response->emit();
    }
    function saveCapitalizeFields(Vtiger_Request $request) {
        $adb = PearDatabase::getInstance();
        $source_module = $request ->get('source_module');
        $field_id = $request ->get('field_id');
        $capitalize_checked = $request ->get('capitalize_checked');
        $method = $request ->get('method');
        if($capitalize_checked == 'true'){
            $sql="SELECT * FROM `vte_capitalize_fields_list` WHERE `module` = ? AND `field_id` =?";
            $rs=$adb->pquery($sql,array($source_module,$field_id));

            if($adb->num_rows($rs)>0) {
                // Update config
                $id=$adb->query_result($rs,0,'id');
                $sql="UPDATE `vte_capitalize_fields_list` SET `module`=?, `field_id`=?,`method` =? WHERE (`id`=?)";
                $adb->pquery($sql,array($source_module,$field_id,$method,$id));
            }else {
                // Add new config
                $sql = 'INSERT INTO `vte_capitalize_fields_list` (`module`, `field_id`, `method`) VALUES (?,?, ?)';
                $adb->pquery($sql,array($source_module,$field_id,$method));
            }
        }
        else{
            $sql="DELETE FROM `vte_capitalize_fields_list` WHERE `module` = ? AND `field_id` =?";
            $rs=$adb->pquery($sql,array($source_module,$field_id));
        }


        $response = new Vtiger_Response();
        $response->setEmitType(Vtiger_Response::$EMIT_JSON);
        $response->setResult( array('success'=>true));
        $response->emit();
    }
}