<?php
/* ********************************************************************************
 * The content of this file is subject to the Capitalize Fields ("License");
 * You may not use this file except in compliance with the License
 * The Initial Developer of the Original Code is VTExperts.com
 * Portions created by VTExperts.com. are Copyright(C) VTExperts.com.
 * All Rights Reserved.
 * ****************************************************************************** */

class CapitalizeFields_Uninstall_View extends Settings_Vtiger_Index_View {

    function process (Vtiger_Request $request) {
        global $adb;
        echo '<div class="container-fluid">
                <div class="widget_header row-fluid">
                    <h3>Capitalize Fields</h3>
                </div>
                <hr>';
        // Uninstall module
        $module = Vtiger_Module::getInstance('CapitalizeFields');
        if ($module) $module->delete();

        // drop tables
		$sql = "DROP TABLE `vte_capitalize_fields_list`;";
        $result = $adb->pquery($sql,array());
		
        echo "&nbsp;&nbsp;- Delete vte_capitalize_fields table";
        if($result) echo " - DONE"; else echo " - <b>ERROR</b>";
        echo '<br>';

        // remove directory
        $res_template = $this->delete_folder('layouts/vlayout/modules/CapitalizeFields');
        echo "&nbsp;&nbsp;- Delete Capitalize Fields template folder";
        if($res_template) echo " - DONE"; else echo " - <b>ERROR</b>";
        echo '<br>';

        $res_module = $this->delete_folder('modules/CapitalizeFields');
        echo "&nbsp;&nbsp;- Delete Capitalize Fields module folder";
        if($res_module) echo " - DONE"; else echo " - <b>ERROR</b>";
        echo '<br>';
        // Remove module from other settings
        $adb->pquery("DELETE FROM vtiger_settings_field WHERE `name` = ?",array('Capitalize Fields'));
      
    }

    function delete_folder($tmp_path){
        if(!is_writeable($tmp_path) && is_dir($tmp_path) && isFileAccessible($tmp_path)) {
            chmod($tmp_path,0777);
        }
        $handle = opendir($tmp_path);
        while($tmp=readdir($handle)) {
            if($tmp!='..' && $tmp!='.' && $tmp!=''){
                if(is_writeable($tmp_path.DS.$tmp) && is_file($tmp_path.DS.$tmp) && isFileAccessible($tmp_path)) {
                    unlink($tmp_path.DS.$tmp);
                } elseif(!is_writeable($tmp_path.DS.$tmp) && is_file($tmp_path.DS.$tmp) && isFileAccessible($tmp_path)){
                    chmod($tmp_path.DS.$tmp,0666);
                    unlink($tmp_path.DS.$tmp);
                }

                if(is_writeable($tmp_path.DS.$tmp) && is_dir($tmp_path.DS.$tmp) && isFileAccessible($tmp_path)) {
                    $this->delete_folder($tmp_path.DS.$tmp);
                } elseif(!is_writeable($tmp_path.DS.$tmp) && is_dir($tmp_path.DS.$tmp) && isFileAccessible($tmp_path)){
                    chmod($tmp_path.DS.$tmp,0777);
                    $this->delete_folder($tmp_path.DS.$tmp);
                }
            }
        }
        closedir($handle);
        rmdir($tmp_path);
        if(!is_dir($tmp_path)) {
            return true;
        } else {
            return false;
        }
    }
}