/* ********************************************************************************
 * The content of this file is subject to the Related List Search ("License");
 * You may not use this file except in compliance with the License
 * The Initial Developer of the Original Code is VTExperts.com
 * Portions created by VTExperts.com. are Copyright(C) VTExperts.com.
 * All Rights Reserved.
 * ****************************************************************************** */
jQuery.Class("CapitalizeFields_Js",{
},{
    //editFields
    registerAddCapitalizeFields: function(string_fields,configuration_fields) {
        var thisInstance = this;
        var url = window.location.href.split('?');
        var array_url = thisInstance.getQueryParams(url[1]);
        if(typeof array_url == 'undefined') return false;
        var module = array_url.module;
        var sourceModule = array_url.sourceModule;
        if(module =="LayoutEditor"){
            jQuery('.editFields').each(function() {
                var field_id = jQuery(this).data('field-id');
                var first_letter = '';
                var everything = '';
                var checked = '';
                jQuery(configuration_fields).each(function(k,v) {
                    if(v.field_id == field_id){
                        checked = 'checked';
                        if( parseInt(v.method) == 0){
                            first_letter = 'checked';
                        }
                        else{
                            everything = 'checked';
                        }
                        return false;
                    }
                });
                //console.log(string_fields[0]);
                if(jQuery.inArray(field_id.toString(),string_fields) >= 0){
                    var inner_form = jQuery(this).find('form.fieldDetailsForm');
                    var settings_div = inner_form.find('div:first').next();
                    settings_div.css('padding-bottom','55px');
                    var capitalFields = '<span class="capitalize-span" id="capitalize_span_'+field_id+'" style="margin-left: 0px;margin-bottom: 5px;">' +
                        '<label style="padding-left: 25px; padding-top: 5px;" class="checkbox">' +
                        '<input type="checkbox" value="0" '+checked+' class="cfm_enable" onclick="return choiceCapitalize(this);">' +
                        '&nbsp;Capitalize' +
                        '</label>' +
                        '<span>' +
                        '<label style="padding-left: 55px; float:left;" class="radio">' +
                        '<input type="radio" value="0" '+first_letter+' name ="capitalize_value_'+field_id+'" class="capitalize_value" onclick="return enableCapitalize(this);">' +
                        '&nbsp;First Letter' +
                        '</label>' +
                        '<label style="float:right;padding-left: 37px;" class="radio">' +
                        '<input type="radio" value="1" '+everything+' name="capitalize_value_'+field_id+'" class="capitalize_value" onclick="return enableCapitalize(this);">' +
                        '&nbsp;Everything' +
                        '</label>' +
                        '</span>' +
                        '</span>';
                    settings_div.append(capitalFields);
                }
            });
        }
        //thisInstance.registerCapitalizeCheck();
    },
    registerDisplayOnDetail:function(module,configuration_fields){
        var thisInstance = this;
        jQuery(configuration_fields).each(function(k,v) {
            var field_name = v.field_name;
            var method = v.method;
            var input_target = jQuery("input[name='"+field_name+"']");
            var parent_span = input_target.closest('span');
            var span_target = parent_span.prev();
            var display_text = span_target.text();
            var capital_text = thisInstance.upperText(display_text.trim(),method);
            span_target.text(capital_text);
        });
    },
    registerDisplayOnEdit:function(module,configuration_fields){
        var thisInstance = this;
        jQuery(configuration_fields).each(function(k,v) {
            var field_name = v.field_name;
            var method = v.method;
            var input_target = jQuery("input[name='"+field_name+"']");
            var display_text = input_target.val();
            if(typeof display_text == "undefined"){
                input_target = jQuery("textarea[name='"+field_name+"']");
                display_text = input_target.text();
            }
            var capital_text = thisInstance.upperText(display_text.trim(),method);
            input_target.val(capital_text);
        });
    },
    upperText: function(str,type_upper){
        if(parseInt(type_upper) == 1){
            return  str.toUpperCase();
        }
        else{
            return str.charAt(0).toUpperCase() + str.slice(1);
        }
    },
    getQueryParams:function(qs) {
        if(typeof(qs) != 'undefined' ){
            qs = qs.toString().split('+').join(' ');
            var params = {},
                tokens,
                re = /[?&]?([^=]+)=([^&]*)/g;
            while (tokens = re.exec(qs)) {
                params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
            }
            return params;
        }
    },
    checkInputChange:function(configuration_fields){
        var instance = this;
        jQuery('input.input-large,textarea').on('keyup change',function(){
            var elementTarget = jQuery(this);
            var this_input = this;
            jQuery(configuration_fields).each(function(index,value){
                var config_field_name = value.field_name;
                if(elementTarget.attr('name') == config_field_name ){
                    var current_value = elementTarget.val();
                    var position=current_value.slice(0, this_input.selectionStart).length;
                    elementTarget.val(instance.upperText(current_value,value.method));
                    this_input.setSelectionRange(position,position);
                }
            });
        });
    },
    registerCapitalizeCheck:function(){
        jQuery('input.cfm_enable').click(function(){
            var parent_span = jQuery(this).closest('span.capitalize-span');
            parent_span.find('input.capitalize_value:first').prop("checked", jQuery(this).is(":checked"));
        });
    }
});
function choiceCapitalize(c_input){
    var parent_span = jQuery(c_input).closest('span.capitalize-span');
    parent_span.find('input.capitalize_value').prop("checked", false);
    parent_span.find('input.capitalize_value:first').prop("checked", jQuery(c_input).is(":checked"));
}
function enableCapitalize(c_input){
    var parent_span = jQuery(c_input).closest('span.capitalize-span');
    parent_span.find('input.cfm_enable').prop("checked", true);
}
jQuery(document).ready(function(){
    //checkEnableModule
    var url = window.location.href.split('?');
    var instance = new CapitalizeFields_Js();
    var array_url = instance.getQueryParams(url[1]);
    if(typeof array_url == 'undefined') return false;
    var module = array_url.module;
    var view = array_url.view;
    if(module =="LayoutEditor"){
        var sourceModule = array_url.sourceModule;
        var params = {
            'module' : 'CapitalizeFields',
            'action': 'ActionAjax',
            'mode': 'checkEnableModule',
            'sourceModule' : sourceModule
        }
        AppConnector.request(params).then(
            function(responseData){
                if(responseData.success){
                    var enabled = responseData.result.enabled;
                    var string_fields = responseData.result.string_fields;
                    var configuration_fields = responseData.result.configuration_fields;
                    if(enabled){
                        instance.registerAddCapitalizeFields(string_fields,configuration_fields);
                        jQuery( document ).ajaxComplete(function(event, xhr, settings) {
                            var url_posted = instance.getQueryParams(settings.data);
                            if(typeof(url_posted) != 'undefined' ){
                                var posted_mode= url_posted.mode;
                                var module= url_posted.module;
                                var fieldid= url_posted.fieldid;
                                if(posted_mode == "save" && module == 'LayoutEditor'){
                                    var capitalize_span = jQuery('#capitalize_span_' +fieldid);
                                    var capitalize_checked = capitalize_span.find('input.cfm_enable').is(":checked");
                                    var capitalize_val = capitalize_span.find('input[name=capitalize_value_'+fieldid+']:checked').val();
                                    //console.log(capitalize_checked + ':' +capitalize_val);
                                    var params = {
                                        'module' : 'CapitalizeFields',
                                        'action': 'ActionAjax',
                                        'mode': 'saveCapitalizeFields',
                                        'source_module' : sourceModule,
                                        'field_id' : fieldid,
                                        'capitalize_checked':capitalize_checked,
                                        'method':capitalize_val
                                    }
                                    AppConnector.request(params).then(
                                        function(resData){

                                        }
                                    );
                                }
                                if(posted_mode == "add" && module == 'LayoutEditor'){
                                    instance.registerAddCapitalizeFields(string_fields,configuration_fields);
                                }
                            }
                        });
                    }
                }
            },
            function(data, err){
                return false;
            }
        );
    }
    //Display on detail view
    if(view == 'Detail'){
        var params = {
            'module' : 'CapitalizeFields',
            'action': 'ActionAjax',
            'mode': 'checkEnableModule',
            'sourceModule' : module
        }
        AppConnector.request(params).then(
            function(responseData) {
                if (responseData.success) {
                    var enabled = responseData.result.enabled;
                    var configuration_fields = responseData.result.configuration_fields;
                    if(enabled){
                        instance.registerDisplayOnDetail(module,configuration_fields);
                        jQuery( document ).ajaxComplete(function(event, xhr, settings) {
                            var url_posted = instance.getQueryParams(settings.url);
                            if(typeof(url_posted) != 'undefined' ){
                                var posted_mode= url_posted.mode;
                                var module= url_posted.module;
                                var fieldid= url_posted.fieldid;
                                //console.log(posted_mode);
                                if(posted_mode == "showDetailViewByMode"){
                                    instance.registerDisplayOnDetail(module,configuration_fields);
                                    instance.checkInputChange(configuration_fields);
                                }
                            }
                        });
                        instance.checkInputChange(configuration_fields);
                    }
                }
            }
        );
    }
    //Display on Edit view
    if(view == 'Edit'){
        var params = {
            'module' : 'CapitalizeFields',
            'action': 'ActionAjax',
            'mode': 'checkEnableModule',
            'sourceModule' : module
        }
        AppConnector.request(params).then(
            function(responseData) {
                if (responseData.success) {
                    var enabled = responseData.result.enabled;
                    var configuration_fields = responseData.result.configuration_fields;
                    if(enabled){
                        instance.registerDisplayOnEdit(module,configuration_fields);
                        instance.checkInputChange(configuration_fields);
                    }
                }
            }
        );
    }
});
